#include "GCCIM.hpp"
#include "DataBases.h"

typedef std::vector < int > VECELE;
typedef std::vector < VECELE > MATELE;

using namespace std;
using namespace Gecode;

///---- Variables ----///
MATELE Solutions; // to store closed patterns
VECELE Transactions_cover; // to store valid transactions
VECELE Frequence_Solution; // to store frequency of each closed pattern
int CurFreq = 1;
double fminsup = 0.0;
int nbr_S = 0;
vector< boost::dynamic_bitset<> > Vertical_DataBase;

//Cover coverD; // instance of Cover class
DataBases DataBasesInstance; // instance of DataBases class	
Search::Statistics GecodeStat; // Gecode's Statistics

///---- Fonctions ----///
void Resolution(int MINFREQ, int NB_ITEMS, int NB_TRANSACTIONS, int ITEMS_CATEGORIES, int TRANSACTIONS_CATEGORIES, int lb_I, int ub_I, int lb_T, int ub_T);
void printStatsGecode(const Gecode::Search::Statistics &stats);
void PostTraitement(MATELE itemset, VECELE Frequence_Solution, VECELE transactions_);

///----- Model ------///
class ItemSetClosed: public Script {	
protected:
  
  // Variables
  IntVarArray PP_0; 
  IntVarArray PP; 
  IntVarArray TT_0;
  IntVarArray TT;
    
public:	
  ItemSetClosed(const Options& opt, int MINFREQ, int NB_ITEMS, int NB_TRANSACTIONS, int ITEMS_CAT, int TRANSACTIONS_CAT, int lb_I, int ub_I, int lb_T, int ub_T): 
    PP_0(*this, NB_ITEMS,0,1), PP(*this, NB_ITEMS,0,1), TT_0(*this, NB_TRANSACTIONS,0,1), TT(*this, NB_TRANSACTIONS,0,1){					
    
    int saut_I = NB_ITEMS/ITEMS_CAT;
    int saut_T = NB_TRANSACTIONS/TRANSACTIONS_CAT;
    
    cout << "#ITEMS_CAT ================= " << ITEMS_CAT << endl;
    cout << "#TRANSACTIONS_CAT ========== " << TRANSACTIONS_CAT << endl;
    cout << "lb_I ======================= " << lb_I << endl;
    cout << "ub_I ======================= " << ub_I << endl;
    cout << "lb_T ======================= " << lb_T << endl;
    cout << "ub_T ======================= " << ub_T << endl;
	cout << "Taille_Cat_I =============== " << saut_I << endl;
	cout << "Taille_Cat_T =============== " << saut_T << endl;
    
    
    
    /**------ DATASET (PP_0, TT_0) ------**/
    // ------------ Q1 ----------------
    // ----- (dé-commenter si Q3) ------
    /*for(int i=0; i<PP_0.size(); i++){
      rel(*this, PP_0[i], IRT_EQ, 1);
    }*/
    // ----- (dé-commenter si Q2) ------
	for(int i=0; i<TT_0.size(); i++){
      rel(*this, TT_0[i], IRT_EQ, 1);
    }
    
	// ------------- Q4 --------------
    // --------- Items categories vectors (commenter si Q3) --------- 	
	/*IntArgs I_catg(ITEMS_CAT*NB_ITEMS);
    Matrix <IntArgs> I_catgs (I_catg, ITEMS_CAT, NB_ITEMS);
    BoolVarArray b_max_I (*this,ITEMS_CAT,0,1);
    BoolVarArray b_min_I (*this,ITEMS_CAT,0,1);
    
    for(int i=0; i<ITEMS_CAT; i++){
		for(int j=0; j<NB_ITEMS; j++)
			I_catgs(i,j)=0;
	}
	for(int i=0; i<ITEMS_CAT; i++){
		for(int j=(i*saut_I); j<((i*saut_I)+(saut_I)); j++)
			I_catgs(i,j)=1;
	}
	
	for(int i=0; i<ITEMS_CAT; i++){
		linear(*this, I_catgs.col(i), PP_0, IRT_EQ, saut_I, b_max_I[i]);
		linear(*this, I_catgs.col(i), PP_0, IRT_EQ, 0, b_min_I[i]);
		rel(*this, b_max_I[i] + b_min_I[i] >= 1);
	}
	 
	linear(*this, b_max_I, IRT_GQ, lb_I);
	linear(*this, b_max_I, IRT_LQ, ub_I);
	 */	
    IntArgs I1(NB_ITEMS);
    I1[0]=1; I1[1]=1; I1[2]=0; I1[3]=0; I1[4]=0; I1[5]=0; I1[6]=0; I1[7]=0; I1[8]=0;
    IntArgs I2(NB_ITEMS);
    I2[0]=0; I2[1]=0; I2[2]=1; I2[3]=1; I2[4]=1; I2[5]=0; I2[6]=0; I2[7]=0; I2[8]=0;
    IntArgs I3(NB_ITEMS);
    I3[0]=0; I3[1]=0; I3[2]=0; I3[3]=0; I3[4]=0; I3[5]=1; I3[6]=1; I3[7]=1; I3[8]=1;
    
    BoolVar b1(*this,0,1);
    linear(*this, I1, PP_0, IRT_EQ, 2, b1); // |I1| = 2
    BoolVar b10(*this,0,1);
    linear(*this, I1, PP_0, IRT_EQ, 0, b10); // |I1| = 2
    rel(*this, b10 + b1 >= 1);
     
    BoolVar b2(*this,0,1);
    linear(*this, I2, PP_0, IRT_EQ, 3, b2); // |I2| = 3
    BoolVar b20(*this,0,1);
    linear(*this, I2, PP_0, IRT_EQ, 0, b20); // |I2| = 3
    rel(*this, b20 + b2 >= 1);
    
    BoolVar b3(*this,0,1);
    linear(*this, I3, PP_0, IRT_EQ, 4, b3); // |I3| = 4
    BoolVar b30(*this,0,1);
    linear(*this, I3, PP_0, IRT_EQ, 0, b30); // |I3| = 4
    rel(*this, b30 + b3 >= 1);
    
    rel(*this, b1+b2+b3 >= lb_I);
    rel(*this, b1+b2+b3 <= ub_I);//*/
    
    // -------- Transactions categories vectors (commenter si Q2) -----------
    /*IntArgs T_catg(TRANSACTIONS_CAT*NB_TRANSACTIONS);
    Matrix <IntArgs> T_catgs (T_catg, TRANSACTIONS_CAT, NB_TRANSACTIONS);
    BoolVarArray b_max_T (*this,TRANSACTIONS_CAT,0,1);
    BoolVarArray b_min_T (*this,TRANSACTIONS_CAT,0,1);
    
    for(int i=0; i<TRANSACTIONS_CAT; i++){
		for(int j=0; j<NB_TRANSACTIONS; j++)
			T_catgs(i,j)=0;
	}
	for(int i=0; i<TRANSACTIONS_CAT; i++){
		for(int j=(i*saut_T); j<((i*saut_T)+(saut_T)); j++)
			T_catgs(i,j)=1;
	}
	
	for(int i=0; i<TRANSACTIONS_CAT; i++){
		linear(*this, T_catgs.col(i), TT_0, IRT_EQ, saut_T, b_max_T[i]);
		linear(*this, T_catgs.col(i), TT_0, IRT_EQ, 0, b_min_T[i]);
		rel(*this, b_max_T[i] + b_min_T[i] >= 1);
	}

	linear(*this, b_max_T, IRT_GQ, lb_T);
	linear(*this, b_max_T, IRT_LQ, ub_T);
    /*
    IntArgs T1(NB_TRANSACTIONS);
    T1[0]=1; T1[1]=1; T1[2]=0; T1[3]=0; T1[4]=0; T1[5]=0;
    IntArgs T2(NB_TRANSACTIONS);
    T2[0]=0; T2[1]=0; T2[2]=1; T2[3]=1; T2[4]=0; T2[5]=0;
    IntArgs T3(NB_TRANSACTIONS);
    T3[0]=0; T3[1]=0; T3[2]=0; T3[3]=0; T3[4]=1; T3[5]=1;
    
    BoolVar b1_(*this,0,1);
    linear(*this, T1, TT_0, IRT_EQ, 2, b1_);
    BoolVar b10_(*this,0,1);
    linear(*this, T1, TT_0, IRT_EQ, 0, b10_); // |I1| = 2
    rel(*this, b10_ + b1_ >= 1);
    
    BoolVar b2_(*this,0,1);
    linear(*this, T2, TT_0, IRT_EQ, 2, b2_);
	BoolVar b20_(*this,0,1);
    linear(*this, T2, TT_0, IRT_EQ, 0, b20_); // |I1| = 2
    rel(*this, b20_ + b2_ >= 1);

    BoolVar b3_(*this,0,1);
    linear(*this, T3, TT_0, IRT_EQ, 2, b3_);
    BoolVar b30_(*this,0,1);
    linear(*this, T3, TT_0, IRT_EQ, 0, b30_); // |I1| = 2
    rel(*this, b30_ + b3_ >= 1);
    
    rel(*this, b1_+b2_+b3_ >= lb_T);
    rel(*this, b1_+b2_+b3_ <= ub_T);*/
    // -------------------------------
    
    /**---- CHANNELING (PP_0, PP, TT_0, TT) ----**/
    // 1) (PP_0[i] = 0) => (PP[i] = 0)
    for(int i=0; i<PP_0.size(); i++){
		rel(*this, PP_0[i], IRT_GQ, PP[i]);
	}	
	// 2) (TT_0[i] = 0) => (TT[i] = 0) 
	for(int i=0; i<TT_0.size(); i++){
		rel(*this, TT_0[i], IRT_GQ, TT[i]);
	}
	
	/**---- MINING(PP, TT) ----**/
	linear(*this, PP, IRT_GR, 0); // avoid the empty pattern
	//linear(*this, PP, IRT_EQ, saut_I); // avoid the empty pattern
	//for(int i=0; i<PP.size(); i+2){
	//	rel(*this, PP[i], IRT_EQ, 0);
	//}
	GCCIM::Closed_Itemset_Constraint(*this, PP, TT, PP_0, TT_0, NB_ITEMS, NB_TRANSACTIONS, MINFREQ); // constraint CLOSEDPATTERN		
  };	
  
  ItemSetClosed(bool share, ItemSetClosed& s) : Script(share, s) {
    PP_0.update(*this, share, s.PP_0);
    PP.update(*this, share, s.PP);
    TT_0.update(*this, share, s.TT_0);
    TT.update(*this, share, s.TT);
  }
  virtual Space* copy(bool share) {
    return new ItemSetClosed(share, *this);
  }
 
 void Branching(){
	IntVarArgs All;	
	All << PP_0;		
	All << TT_0;
	All << PP;		
	All << TT;		
	branch(*this, All, INT_VAR_NONE(), INT_VAL_MIN()); // Branching VAR/VAL
  }		
  void Save_Solutions(){ // Save each found solution
    VECELE v;
    for(int i=0; i<PP.size(); i++){
      v.push_back(PP[i].val());
    }
    Solutions.push_back(v);
    Frequence_Solution.push_back(CurFreq); // Save frequency of each found solution
    
    /*cout << " TT_0 " << endl;
    for(int i=0; i<TT_0.size(); i++){
      cout << " " << TT_0[i] << "";
      //Transactions_cover.push_back(TT[i].val());
    }cout << " " << endl;
    cout << " PP_0 " << endl;
    for(int i=0; i<PP_0.size(); i++){
      cout << " " << PP_0[i] << "";				
    }cout << " -------------- " << endl;*/
    //nbr_S++;
    //cout << " nbr_S = " << nbr_S << endl;
  }  
};

///---- Main() ----///
int main (int argc, char* argv[])   {
  
  /** CPU time Total **/
  struct rusage usage;
  struct timeval end;
  getrusage(RUSAGE_SELF, &usage);	
  
  /** Reading Parameters **/	
  if(argc < 3) {
    cerr << "Usage : ./main datafile minsup[given in %] #items_categories #transactions_categories lb_I ub_I lb_T ub_T" << endl;
    return 1;
  }				
  string DataBaseFile = argv[1];
  fminsup = atof(argv[2]); // minsup (%)	
  int items_categories = atoi(argv[3]); // #items_categories
  int transactions_categories = atoi(argv[4]); // #transactions_categories
  int lb_I = atoi(argv[5]);
  int ub_I = atoi(argv[6]);
  int lb_T = atoi(argv[7]);
  int ub_T = atoi(argv[8]);
  
  /** Get Dataset **/
  DataBasesInstance.GetData(DataBaseFile); // Load original database
  int minsup = round(fminsup*double(DataBasesInstance.initial_DataBase.size())); // absolute minsup
 
  DataBasesInstance.Preprocessing_DataBase(minsup); // Processing database		
  DataBasesInstance.Create_Boolean_Matrix(); // Generate boolean matrix
  DataBasesInstance.Create_Vertical_DataBase(); // Create vertical representation (bitvector)
  Vertical_DataBase = DataBasesInstance.Vertical_DataBase; // Get vertical representation
  int nbrItems = Vertical_DataBase.size();
  int nbrTransactions = Vertical_DataBase[1].size();
  
  /** Start Resolution **/
  //coverD.Initial_Cover(); // Initial cover (id of all transactions)	
   Resolution(minsup, nbrItems, nbrTransactions, items_categories, transactions_categories, lb_I, ub_I, lb_T, ub_T); // resolution
  
  /** End timer (Total) **/	
  getrusage(RUSAGE_SELF, &usage);
  end = usage.ru_utime;
  printf("USER Time (Total) =  %ld.%lds\n", end.tv_sec, end.tv_usec);			
  
  PostTraitement(Solutions, Frequence_Solution, Transactions_cover); // Get patterns	
  printStatsGecode(GecodeStat); // Gecode statistics
  
  return 0;		 		 
} 
///---- End Main() ----/// 

///---- Resolution () ----
void Resolution(int Fmin, int nbItems, int nbTransactions, int catItems, int catTransactions, int lb_I, int ub_I, int lb_T, int ub_T){
  
  Options opt("/***** Solutions ******/\n");
  opt.solutions(0);
  
  ItemSetClosed* s = new ItemSetClosed(opt, Fmin, nbItems, nbTransactions, catItems, catTransactions, lb_I, ub_I, lb_T, ub_T);
  s->Branching();
  DFS<ItemSetClosed> e(s); 
  delete s;
  
  while (ItemSetClosed* sol = e.next()){
    sol->Save_Solutions();	
    delete sol;		
  }	
  GecodeStat = e.statistics();
}
/// Prints Statistiques Gecode
void printStatsGecode(const Gecode::Search::Statistics &stats){
  printf("-------------------------------------------------------\n");
  cout <<"Solver search statistics: " << endl;
  cout <<"Propagators  ================ "<< stats.propagate << endl;
  cout <<"Nodes  ====================== "<< stats.node << endl;
  cout <<"Failed nodes  =============== "<< stats.fail << endl;
  cout <<"Memory ====================== "<< stats.memory << endl;						
}

///---- PostTraitement () ----
void PostTraitement(MATELE itemset, VECELE Freqs, VECELE transactions_){	
  
  cout << "\nN° of patterns === " << itemset.size() << endl;
  cout << "\nFrequent Closed Pattrens :\n" << endl;
  MATELE Motifs;
  VECELE motif_temp;
  for (unsigned int i = 0; i < itemset.size(); i++){
    for (unsigned int j = 0; j < itemset[i].size(); j++){				
      if(itemset[i][j] == 1){							
	motif_temp.push_back(j+1);
      }
    }
    Motifs.push_back(motif_temp);
    // Print closed patterns
    cout << "< ";
    for(unsigned int k = 0; k < motif_temp.size(); k++){
      cout << motif_temp[k] << " ";
    }cout << "> : " << Freqs[i] << endl;
    motif_temp.clear();
  }
  
 /* for (unsigned int i = 0; i < transactions_.size(); i++){
    cout << transactions_[i] << " ";
  }cout << endl;*/  
}

/*

	cout << "#ITEMS_CAT ========= " << ITEMS_CAT << endl;
    cout << "#TRANSACTIONS_CAT == " << TRANSACTIONS_CAT << endl;
    cout << "lb_I =============== " << lb_I << endl;
    cout << "ub_I =============== " << ub_I << endl;
    cout << "lb_T =============== " << lb_T << endl;
    cout << "ub_T =============== " << ub_T << endl;
	cout << "saut =============== " << saut << endl;
    
    MATELE test;
    VECELE tes;
    for(int i=0; i<ITEMS_CAT; i++){
		tes.clear();
		for(int j=0; j<NB_ITEMS; j++){
			tes.push_back(0);
		}
		test.push_back(tes);
	}
	for(int i=0; i<ITEMS_CAT; i++){
		for(int j=(i*saut); j<((i*saut)+(saut)); j++){
			test[i][j] = 1;
		}
	}/*
	
	for(int i=0; i<test.size(); i++){
		for(int j=0; j<test[i].size(); j++){
				cout << test[i][j] << " ";
		}
		cout << endl;
    }
*/
